package unsw891.optimiser;

import unsw891.sml.*;

/**
 * All optimisers, local and global, must implement this interface.
 */
public interface Optimiser extends Runnable {
	
	/**
	 * Return the current optimal Document
	 */
	public Document outputResult();
	
	/**
	 * Return true iff all possibile optimisation on the
	 * stored document by this optimiser is complete.
	 */
	public boolean isFinished();
	
	/**
	 * Continue optimisation on the stored Document
	 */
	public void run();

	/**
	 * Stop optimisation at the next safe internal breakpoint.
	 */
	public void stop();
	
}
