package unsw891.optimiser;

import unsw891.optimiser.*;
import unsw891.sml.*;

public class OptimiserWrapper {

  public static boolean dontUseValidator = false;
  
  /**
   *No one should call this except John. There are somethings dodgy about
   *this if not called properly
   */
  public static Document optimise(Optimiser opt, Document sourceDoc) {
  	//at the moment the Document inside opt is the same pointer as sourceDoc
	sourceDoc = (Document)sourceDoc.clone();
	
	try {
	  opt.run();
  	  Document tmpDoc = opt.outputResult();
  	  if (dontUseValidator || Validator.SMLEquivalent(sourceDoc, tmpDoc)) {
  	  	System.err.println("SMLOPTIMISER: Accepted optimisation: " + opt);
		System.err.println("Percentage Reduction (Excluding text strings): " +
		                    (100.0*(sourceDoc.tagSize()-tmpDoc.tagSize())/sourceDoc.tagSize()) + "%");
		return tmpDoc;
  	  } else {
		System.err.println("Ran but rejected the optimiser: " + opt);
		System.err.println("---output of rejected optimiser-------------");
		System.err.println(tmpDoc);
		System.err.println("--------------------------------------------");
	  }
	} catch (Exception e) {
	  e.printStackTrace();
	  System.err.println("Some exception was thrown when running validator and optimiser: " + opt);
	}
	return sourceDoc;
  }
}
