package unsw891.optimiser.global;

import unsw891.sml.*;
import java.util.*;


// This is a stub file


/**
 * operations on DNA codes
 */
public class DnaCode {


  static int fromByte(byte b) {
  	return ((int) b) & 0xff;
  }

  static int getCost(byte[] dnaCode) {
  	// first 3 bytes store the cost
	return (fromByte(dnaCode[0]) << 16) | (fromByte(dnaCode[1]) << 8)
	       | (fromByte(dnaCode[2]));
  }
  
  
  public static Document toDoc(byte[] dnaCode, Shard[] shards, Heuristics heurs) {
  
    int i;
     
    // prepare a document and a shard stack
    Document ret = new Document(Document.TAG_ROOT);
    Document currentD = ret;
    ShardStack stack = new ShardStack();
    Shard currentS = new Shard();
    stack.push(currentS);
    

    // go through the shard array now  
    
    for (i = 0; i < shards.length; i++) {
      
      // okay, we have to work out how many things to pop off the stack
	  // let the DNA class do this for us
	  DNA dnaObj = new DNA(stack, shards[i],heurs);
	  int bestDnaCode = dnaCode[i+3];
  	  Vector newTags = dnaObj.getNewTags(bestDnaCode);
	  currentS = stack.peek();
  	  for (int j = 1; j < bestDnaCode; j ++) {
	  	currentD = currentD.parent;
	  }	  
	        
      // now we work out which order to open the tags in
      // and then proceed to do so.
      
      newTags = heurs.sortTags(newTags);
	  Document newNode;
      for (int j = 0; j < newTags.size(); j++) {
        newNode = (Document) newTags.elementAt(j);
        currentS = new Shard(currentS);
        currentS.modify(newNode.type);
        stack.push(currentS);
        newNode.parent = currentD; // add a reference to the parent
        currentD.children.add(newNode); // add the child
        currentD = newNode;
      }
    
      newNode = new Document(Document.TAG_TEXT, shards[i].text);
      newNode.parent = currentD;
      currentD.children.add(newNode);
      
      heurs.update(shards[i]);
    
    } // end of shard array loop 

    return ret;
	
  }
  
  
  public static byte[] invent(Shard[] shards, Heuristics heurs) { 

    int i;
    
    // prepare a shard stack and dna code
    ShardStack stack = new ShardStack();
    Shard currentS = new Shard();
    stack.push(currentS);
	byte[] dnaCode = new byte[shards.length + 3];
    int totalCost = 0;

    // go through the shard array now  
    
    for (i = 0; i < shards.length; i++) {
      
      // okay, we have to work out how many things to pop off the stack
	  // let the DNA class do this for us
	  DNA dnaObj = new DNA(stack, shards[i],heurs);
	  int bestDnaCode = dnaObj.getSortedCodes()[0];
  	  Vector newTags = dnaObj.getNewTags(bestDnaCode);
	  currentS = stack.peek();
	        
	
	  // store the dnaCode
  	  dnaCode[i+3] = (byte) bestDnaCode;      
	  totalCost += dnaObj.getCosts()[bestDnaCode];
      heurs.update(shards[i]);
	  
	  // update the stack
	  newTags = heurs.sortTags(newTags);
      for (int j = 0; j < newTags.size(); j++) {
        int newType = ((Document) newTags.elementAt(j)).type;
        currentS = new Shard(currentS);
        currentS.modify(newType);
        stack.push(currentS);
      }

    
    } // end of shard array loop 

  	// store the cost
  	dnaCode[0] = (byte) ((totalCost & 0xff0000) >> 16);
	dnaCode[1] = (byte) ((totalCost & 0x00ff00) >> 8);
	dnaCode[2] = (byte) (totalCost & 0x0000ff);
    return dnaCode;
  }


  public static byte[] mutate(byte[] prevCode) {
    return prevCode;
  }




}
