package unsw891.optimiser.global;

import unsw891.util.Debug;


class HeurColor {

    public static final int SIZE_COUNT = 10;


    public int startpos; // inclusive
    public int endpos;   // inclusive

    public int cr;
    public int cg;
    public int cb;
    public int cc;
    public int cm;
    public int cy;
    public int ck;
    public int cw;



    public HeurColor(int pos) {
        startpos = pos;

        cr = 0;
        cg = 0;
        cb = 0;
        cc = 0;
        cm = 0;
        cy = 0;
        ck = 0;
        cw = 0;
    }
    
    
    public HeurColor(HeurColor hc) {
        startpos = hc.startpos;
        endpos = hc.endpos;
        
        cr = hc.cr;
        cg = hc.cg;
        cb = hc.cb;
        cc = hc.cc;
        cm = hc.cm;
        cy = hc.cy;
        ck = hc.ck;
        cw = hc.cw;
    }



    public void incr(char colour) {
        switch (colour) {
        
            case 'r':
                ++cr;
            break;
            
            case 'g':
                ++cg;
            break;
            
            case 'b':
                ++cb;
            break;
            
            case 'c':
                ++cc;
            break;
            
            case 'm':
                ++cm;
            break;
            
            case 'y':
                ++cy;
            break;
            
            case 'k':
                ++ck;
            break;
            
            case 'w':
                ++cw;
            break;
            
            default:
                Debug.assert(false, "HeurColor: bad colour to increment");
        }
    }



    public void decr(char colour) {
        switch (colour) {
        
            case 'r':
                --cr;
            break;
            
            case 'g':
                --cg;
            break;
            
            case 'b':
                --cb;
            break;
            
            case 'c':
                --cc;
            break;
            
            case 'm':
                --cm;
            break;
            
            case 'y':
                --cy;
            break;
            
            case 'k':
                --ck;
            break;
            
            case 'w':
                --cw;
            break;
            
            default:
                Debug.assert(false, "HeurColor: bad colour to decrement");
        }
    }


    public int getVal(char c) {
        switch (c) {
        
            case 'r':
                return cr;
            
            case 'g':
                return cg;
            
            case 'b':
                return cb;
            
            case 'c':
                return cc;
            
            case 'm':
                return cm;
            
            case 'y':
                return cy;
            
            case 'k':
                return ck;
            
            case 'w':
                return cw;
            
            default:
                Debug.assert(false, "HeurColor: bad colour to count");
                return 'x';
        }
    }

}

