package unsw891.optimiser.local;

import unsw891.sml.*;
import unsw891.optimiser.*;

public class LocalOptimisers implements Optimiser {

	private Document sourceDoc;
	
	public LocalOptimisers(Document doc) {
		sourceDoc = doc;
	}

	/**
	 * <MODIFICATION LOG>
	 * Sunday 5pm - John - Made it better
	 * Friday 4:45pm - John Lai - created but not yet complete. Needs to run all local optimisers
	 */
	public Document outputResult() {
	  	Document curBest = (Document)(sourceDoc.clone());	
		
		//white space compression (simple)
		curBest = OptimiserWrapper.optimise(new unsw891.optimiser.local2.LocalOptimiser(curBest), curBest);
		
		//redundency
		curBest = OptimiserWrapper.optimise(new unsw891.optimiser.local4.LocalOptimiser(curBest), curBest);
		
		//EM elimination
  	  	curBest = OptimiserWrapper.optimise(new unsw891.optimiser.local1.LocalOptimiser(curBest), curBest);
		
		//white space elimination (hard)
		curBest = OptimiserWrapper.optimise(new unsw891.optimiser.local8.LocalOptimiser(curBest), curBest);
		
		//redundency
		curBest = OptimiserWrapper.optimise(new unsw891.optimiser.local4.LocalOptimiser(curBest), curBest);
		
		return curBest;
	}
		
	
	public boolean isFinished() {
		return true;
	}
	
	public void run() {
		
	}

	public void stop() {
		
	}
	
}
