package unsw891.optimiser.local4;

import unsw891.sml.*;
import unsw891.optimiser.*;
import java.util.*;

public class LocalOptimiser implements Optimiser {

	private Document doc;
	
	public LocalOptimiser(Document doc) {
		this.doc = doc;
	}

	/**
	 * <MODIFICATION LOG>
         * Saturday 12:41pm - Arthur - completed.  Requires testing.
	 * Friday 5:02pm - John Lai - created but not yet complete. Need to add some
	 * local optimisations
	 */
	public Document outputResult() {
	
		// System.out.println("unsw891.local4.LocalOptimiser.outputResult() not yet implemented");
		
		// Optimization starts here - arthurl
                
                Document documentRoot = this.doc;
                ContextStack stack    = new ContextStack();
                
                optimize(documentRoot, stack);
		
		return documentRoot;
	}
		
        private Document optimize(Document documentRoot, ContextStack stack) {
        
                for (int i = 0; i < documentRoot.children.size(); i++) {
                    Document node = (Document) documentRoot.children.elementAt(i);
                    
                    if (node.type == Document.TAG_TEXT) {
                      continue;
                    }
                    
					if (node.children.size()==0) {
					    documentRoot.children.remove(i);
						i--;
				  	}
					
					stack.pushContext();
                    
                    Context topContext = stack.topContext();
                    switch (node.type) {
                        case Document.TAG_ROOT:
                        case Document.TAG_TEXT:
                            break;
                        case Document.TAG_B:
                            topContext.b = true;
                            break;
                        case Document.TAG_EM:
                            if (!topContext.s) {
                                topContext.em = !topContext.em;
                            }
                            break;
                        case Document.TAG_I:
                            topContext.i  = true;
                            break;
                        case Document.TAG_PL:
                            topContext.b  = false;
                            topContext.em = false;
                            topContext.i  = false;
                            topContext.tt = false;
                            topContext.s  = false;
                            topContext.u  = 0;
                            break;
                        case Document.TAG_S:
                            topContext.em = false;
                            topContext.s  = true;
                            break;
                        case Document.TAG_TT:
                            topContext.tt = true;
                            break;
                        case Document.TAG_U:
                            if (topContext.u < 3) { topContext.u++; }
                            break;
                        case Document.TAG_0:
                        case Document.TAG_1:
                        case Document.TAG_2:
                        case Document.TAG_3:
                        case Document.TAG_4:
                        case Document.TAG_5:
                        case Document.TAG_6:
                        case Document.TAG_7:
                        case Document.TAG_8:
                        case Document.TAG_9:
                            topContext.size = (node.type - Document.TAG_0);
                            break;
                        case Document.TAG_r:
                            topContext.colour = 'r';
                            break;
                        case Document.TAG_g:
                            topContext.colour = 'g';
                            break;
                        case Document.TAG_b:
                            topContext.colour = 'b';
                            break;
                        case Document.TAG_c:
                            topContext.colour = 'c';
                            break;
                        case Document.TAG_m:
                            topContext.colour = 'm';
                            break;
                        case Document.TAG_y:
                            topContext.colour = 'y';
                            break;
                        case Document.TAG_k:
                            topContext.colour = 'k';
                            break;
                        case Document.TAG_w:
                            topContext.colour = 'w';
                            break;                            
                    }
                    
                    if (compareTopContexts(stack)) {
                        documentRoot.children.remove(i);
						documentRoot.children.addAll(i, node.children);
                        i--;
                    } else {
                        optimize(node,stack);                
                    }
                    stack.popContext();
                }
                
                return documentRoot;
        }
        
	public boolean compareTopContexts(ContextStack stack) {
                Context top = stack.topContext();
                Context second = stack.secondTopContext();
                
                return top.equals(second);
        }
        
	public boolean isFinished() {
		//System.out.println("unsw891.local4.LocalOptimiser.isFinished() not yet implemented");
		return true;
	}
	
	public void run() {
		//System.out.println("unsw891.local4.LocalOptimiser.run() not yet implemented");
		
	}

	public void stop() {
		//System.out.println("unsw891.local4.LocalOptimiser.stop() not yet implemented");
		
	}
        
        public String toString() {
               return ("arthurl - local optimization 4 - redundancy");
        }
        	
}
