package unsw891.optimiser.local5;

import unsw891.sml.*;
import unsw891.optimiser.*;

/* Optimiser for:
 * overlap inversion
 *   changing
 *           <B><I>bla bla</I></B><TT><I><B>foo bar</B></I> truc</TT>
 *   into
 *           <B><I>bla bla<TT>foo bar</TT></I></B><TT> truc</TT>
 */

public class LocalOptimiser implements Optimiser {

	private Document doc;
	
	public LocalOptimiser(Document doc) {
		this.doc = doc;
	}

	/**
	 * <MODIFICATION LOG>
	 * Friday 5:02pm - John Lai - created but not yet complete. Need to add some
	 * local optimisations
	 * Saturday 12:45pm - simonb - working on local optimiser for 
	 *                             overlap inversions.
	 */
	public Document outputResult() {
	
		System.out.println("unsw891.local5.LocalOptimiser.outputResult() not yet implemented");
		
		ShardStack stack = null; // fix this when Convertor is working

		//Run your optimisation
                for (int i=0; i < doc.children.size(); i++) {
                    optimise((Document) doc.children.get(i),stack);
		}
		return doc;
	}
    
        public Document optimise(Document doc, ShardStack stack) {
            if (doc.type != Document.TAG_TEXT && doc.type != Document.TAG_INVALID) {
                if (doc.type != Document.TAG_I) {
                    doc.type = Document.TAG_I;
                } else {
                    for (int i=0; i < doc.children.size(); i++) {
                        optimise((Document) doc.children.get(i),stack);
                    }
                }
            } 
            return doc;
        }

	public boolean isFinished() {
		System.out.println("unsw891.local5.LocalOptimiser.isFinished() not yet implemented");
		return true;
	}
	
	public void run() {
		System.out.println("unsw891.local5.LocalOptimiser.run() not yet implemented");
		
	}

	public void stop() {
		System.out.println("unsw891.local5.LocalOptimiser.stop() not yet implemented");
		
	}

   
	
}
