package unsw891.optimiser.local6;

import unsw891.sml.*;
import unsw891.optimiser.*;
import java.util.*;

public class LocalOptimiser implements Optimiser {

	private Document doc;
	
	public LocalOptimiser(Document doc) {
		this.doc = doc;
	}

	/**
	 * <MODIFICATION LOG>
	 * Friday 5:02pm - John Lai - created but not yet complete. Need to add some
	 * local optimisations
	 */
	public Document outputResult() {
	
		// System.out.println("unsw891.local6.LocalOptimiser.outputResult() not yet implemented");
		
		// Optimization starts here - arthurl
                
                Document documentRoot = this.doc;
                ContextStack stack    = new ContextStack();
                
                documentRoot.genLinks();
                optimize(documentRoot, stack);
		
		return documentRoot;
	}
		
        private Document optimize(Document documentRoot, ContextStack stack) {
                
                for (int i = 1; i < (documentRoot.children.size()-1); i++) {
                    Document leftNode  = (Document) documentRoot.children.elementAt(i-1);
                    Document thisNode  = (Document) documentRoot.children.elementAt(i);
                    Document rightNode = (Document) documentRoot.children.elementAt(i+1);
                    
                    stack.pushContext();
                    
                    Context topContext = stack.topContext();
                    
                    Context leftContext = updateContext((Context)topContext.clone(), leftNode);
                    Context thisContext = updateContext((Context)topContext.clone(), thisNode);
                    Context rightContext = updateContext((Context)topContext.clone(), rightNode);
                    
                    if (leftContext.equals(rightContext)) { /* split the children in the root node */
                        // test if the middle one is plain/can be optimized.
                        // if so, 
                        // documentRoot.children.......
                        
                        // put middle branch to documentRoot.parent();
                        
                    }
                    
                    optimize(thisNode,stack);
                    
                    stack.popContext();
                }
                
                return documentRoot;
        }
        
	public boolean compareTopContexts(ContextStack stack) {
                Context top = stack.topContext();
                Context second = stack.secondTopContext();
                
                return top.equals(second);
        }
        
        public Context updateContext(Context c, Document node) {
                switch (node.type) {
                        case Document.TAG_ROOT:
                        case Document.TAG_TEXT:
                            break;
                        case Document.TAG_B:
                            c.b = true;
                            break;
                        case Document.TAG_EM:
                            if (!c.s) {
                                c.em = !c.em;
                            }
                            break;
                        case Document.TAG_I:
                            c.i  = true;
                            break;
                        case Document.TAG_PL:
                            c.b  = false;
                            c.em = false;
                            c.i  = false;
                            c.tt = false;
                            c.s  = false;
                            c.u  = 0;
                            break;
                        case Document.TAG_S:
                            c.em = false;
                            c.s  = true;
                            break;
                        case Document.TAG_TT:
                            c.tt = true;
                            break;
                        case Document.TAG_U:
                            if (c.u < 3) { c.u++; }
                            break;
                        case Document.TAG_0:
                        case Document.TAG_1:
                        case Document.TAG_2:
                        case Document.TAG_3:
                        case Document.TAG_4:
                        case Document.TAG_5:
                        case Document.TAG_6:
                        case Document.TAG_7:
                        case Document.TAG_8:
                        case Document.TAG_9:
                            c.size = (node.type - Document.TAG_0);
                            break;
                        case Document.TAG_r:
                            c.colour = 'r';
                            break;
                        case Document.TAG_g:
                            c.colour = 'g';
                            break;
                        case Document.TAG_b:
                            c.colour = 'b';
                            break;
                        case Document.TAG_c:
                            c.colour = 'c';
                            break;
                        case Document.TAG_m:
                            c.colour = 'm';
                            break;
                        case Document.TAG_y:
                            c.colour = 'y';
                            break;
                        case Document.TAG_k:
                            c.colour = 'k';
                            break;
                        case Document.TAG_w:
                            c.colour = 'w';
                            break;                            
                }
                return c;
        }
        
	public boolean isFinished() {
		System.out.println("unsw891.local6.LocalOptimiser.isFinished() not yet implemented");
		return true;
	}
	
	public void run() {
		System.out.println("unsw891.local6.LocalOptimiser.run() not yet implemented");
		
	}

	public void stop() {
		System.out.println("unsw891.local6.LocalOptimiser.stop() not yet implemented");
		
	}
        
        public String toString() {
               return ("arthurl - local optimization 6 - PL elimination");
        }
        	
}
