package unsw891.sml;

import unsw891.sml.*;
import java.util.Stack;

/**
 *A context stack, much like an openGL stack.
 *<MODIFICATION LOG>
 * Saturday 11:30am - John - completed ContextStack
 */
public class ContextStack {
	
	private Stack stack;
	
	/**
	 * Creates a new stack containing a root context
	 */
	public ContextStack() {
		stack = new Stack();
		stack.push(new Context());
	}
	
	/**
	 * Push another copy of the top Context onto the stack
	 */
	public Context pushContext() {
		Context newTop = (Context)(topContext().clone());
		stack.push(newTop);
		return newTop;
	}
	
	/**
	 * Pop off the top of the stack
	 */
	public Context popContext() {
		
		return (Context)stack.pop();
	}
	
	/**
	 * returns the top context without actually removing it
	 * from the stack
	 */
	public Context topContext() {
		return (Context)stack.peek();
	}
	
	public synchronized Context secondTopContext() {
		Context top = popContext();
		Context second = topContext();
		stack.push(top);
		return second;
	}
}
