package unsw891.sml;

import unsw891.sml.*;
import java.util.*;
import unsw891.util.*;
import unsw891.parser.Parser;
import java.io.*;
import unsw891.optimiser.local4.*;
import unsw891.optimiser.*;


/**
 * 
 * NEEDS TO BE TESTED -Sherman ;)
 * Compares whether two documents are equivalent
 * <MODIFICATION LOG>
 * 7:19pm Friday - Jordan - Started work on Validator
 * 2.00pm Sunday - Jordan - Finished..ish */
public class Validator {


	public static boolean DEBUG = false;
	/*  SMLEquivalent will take two documents, convert them into 
	    propery record vectors and compare them syntactically.
        If it runs into an error, it will print out the first 
        difference in each record to stderr  
	*/
    
    public static void main(String[] args) {

        String FILENAME = "./testing/local2test4";
		  String OUTPUT = "./testing/local2test4b";
        try{
            Document doc = Parser.parse(new FileInputStream(FILENAME));

            Document doc2 = Parser.parse(new FileInputStream(OUTPUT));

				//getCompressedShards(doc);            
				
            System.out.println(SMLEquivalent(doc,doc2));
            
        }
        catch(IOException e) {
            System.err.println("Unable to open file " + FILENAME);
            e.printStackTrace();
            System.exit(1);
        }

    }
	public static boolean SMLEquivalent(Document doc1, Document doc2) {
			System.err.println("RUNNING VALIDATOR");
			Vector vec1 = getCleanVector(doc1);
			Vector vec2 = getCleanVector(doc2);

			ListIterator iter1 = vec1.listIterator();
			ListIterator iter2 = vec2.listIterator();

		
        Shard pr1,pr2,test;
        
        while(iter1.hasNext() && iter2.hasNext()) {
            pr1 = (Shard) iter1.next();
            pr2 = (Shard) iter2.next();
				
				if(DEBUG) {
					System.out.println(pr1);
					System.out.println(pr2);
				}
			
            if(!isEqiv(pr1,pr2)) {
					System.err.println("unsw891.sml.Validator.SMLEquivalent:: Documents Differ");
					printError(pr1,pr2);
					return false;
				}
					
        }
        
        if(!iter1.hasNext() && !iter2.hasNext())
            return true;
        
        if(!iter1.hasNext()) {
            pr2 = (Shard) iter2.next();
            System.err.println("unsw891.sml.Validator.SMLEquivalent:: Document 2 is longer than Document 1.");
			System.err.println("Document 2 contains \n" + pr2.toString());
            return false;
        }
        else {
            pr1 = (Shard) iter1.next();
            System.err.println("unsw891.sml.Validator.SMLEquivalent:: Document 1 is longer than Document 2.");
			System.err.println("Document 1 contains \n" + pr1.toString());
            return false;

        }
        
            
	}
    

	
    
    /** printRecord is a pretty-printing function for the context of an error 
     *  <MODIFICATION LOG>
     *   20:19, Friday - Jordan - Created method
     */
    
    private static String printRecord(Shard rec,int num) {

        String delimiter = "******************************\n";

        String record = delimiter;
        
        if(rec!=null && !rec.text.equals("")) {
            record += "Document " + num + " contained text:\n";
            record += "\"" + rec.text + "\"\n";
        }
        else
        {
            record += "Document " + num + " contained no text";
        }
            
        return record;
    }
     
    /** printError is cos i am excessivly lazy
     *  <MODIFICATION LOG>
     *   20:19, Friday - Jordan - Created method
     */


    private static void printError(Shard one, Shard two) {
        
        System.err.println(printRecord(one,1));
        System.err.println(printRecord(two,2));
		  if(one.text.equals(two.text))
		  		System.err.println("Text is equal, see below for contex difference");

        compareShards(one,two);
    }

    /** compareShards will print out the parts of the context that differ
     *  <MODIFICATION LOG>
     *   20:19, Friday - Jordan - Created method
	  *   11:59, Sat - Jordan -Converted to use Shard
     */
    private static void compareShards(Shard a,Shard b) {
        if(a.isBold()!=b.isBold())
            if(a.isBold())
                System.err.println("Context one is bold");
            else
                System.err.println("Context two is bold");
            
		if(a.isEm() != b.isEm())
            if(a.isEm())
                System.err.println("Context one is emphatic");
            else
                System.err.println("Context two is emphatic");
                
         if(a.isItalic() != b.isItalic())
            if(a.isItalic())
                System.err.println("Context one is italic");
            else
                System.err.println("Context two is italic");       
                
        if(a.isTT() != b.isTT())
            if(a.isTT())
                System.err.println("Context one is teletype");
            else
                System.err.println("Context two is teletype");
		  
			if(a.isTT())
				System.err.println("Teletype is on");
				
        
        if(a.isUnderline() != b.isUnderline()) {
            System.err.println("Context one has underline "+ a.isUnderline());
            System.err.println("Context two has underline "+ b.isUnderline());
        }
                                
        if(a.size != b.size) {
            System.err.println("Context one has size "+ a.size);
            System.err.println("Context two has size "+ b.size);
        }
        
        if(a.colour != b.colour) {
            System.err.println("Context one has colour "+ a.colour);
            System.err.println("Context two has colour "+ b.colour);
        }
           
		if(a.isStrong() != b.isStrong())
            if(a.isStrong())
                System.err.println("Context one is strong");
            else
                System.err.println("Context two is strong");
		        

    }
    
    /**
     * isEqiv will test the eqivelance of two PropertyRecords.
     * <MODIFICATION LOG>
     * 01:04 Saturday - Jordan - Creating method in hope of finishing class
     * why I am doing this is a good question, as there is a good chance that i
     * could be making out with someone at a pub.... questions, people?
     *
     */
    private static boolean isEqiv(Shard one, Shard two) {
        
      boolean whiteSpace = true;

		if(!isWhiteSpace(one) || !isWhiteSpace(two))
			whiteSpace = false;
            
      if(!whiteSpace) {
			if(one.text.equals(two.text)) {
                if(one.textEquals(two))
                    return true;
                else
                    return false;
            }
            else return false;
        }
        else{
            if(one.whiteSpaceEquals(two))
                return true;
            else return false	;
        }
       
    }  
	/* can get away with using Character.isWhitespace as they promise the only 
	unprintable chars are space, lf, cr and tab.. everything is valid ascii*/
	private static boolean isWhiteSpace(Shard foo){
		for(int i = 0 ; i < foo.text.length() ; i++) {
            if(!Character.isWhitespace(foo.text.charAt(i))) 
                return false;
		}
		return true;
	}
	
	/* first pass of the shard fixer-upperer */
	private static Vector makeSpaceShards(Vector input) {
		Vector output = new Vector();
		StringBuffer current;
		Shard foo;
		for(int x = 0 ; x < input.size() ; x++) {
			foo = (Shard) input.get(x);
			current = new StringBuffer();			
			//examine string now
			String cString = foo.text;
			if (foo.isTT()) {
				output.add(foo);
				continue;
			}
			for(int i = 0 ; i < cString.length() ; i++) {
				char test = cString.charAt(i);
		
				if(Character.isWhitespace(test)){

					if(current.length() != 0) {
						Shard oldShard = new Shard(current.toString(),foo);
						output.add(oldShard);
						current = new StringBuffer();
					}
					
					Shard spaceShard = new Shard("" + test, foo);
					output.add(spaceShard);					
									
				}
				else
					current.append(test);
			
			}
			
			if(current.length()!=0)
				output.add(new Shard(current.toString(),foo));
		
		}
		
		return output;

	}
	
	private static Vector foldSpaceShards(Vector input) {
		Vector output = new Vector();
		Shard lastSpace = null;
		for(int x = 0 ; x < input.size() ; x++) {
			Shard foo = (Shard) input.get(x);
			if(foo.isTT()) {
				output.add(foo);
				continue;
			}
			else if (isWhiteSpace(foo)) {
					if( lastSpace!=null && !lastSpace.whiteSpaceEquals(foo)) {
						output.add(lastSpace);
						lastSpace = null;	
					}
						

					lastSpace = foo;
			}
			else{

				 if(lastSpace !=null)
					 output.add(lastSpace);

				 output.add(foo);
			}
		}
		
		if(lastSpace!=null)
			output.add(lastSpace);
	
		return output;
	}

	private static Vector getCleanVector(Document doc) {
		return foldSpaceShards(makeSpaceShards(Converter.getShardVector(doc)));
	}

	/* getCompressedShards is for stephen :) */
	public static Vector getCompressedShards(Document doc) {
		
		Vector orig = Converter.getShardVector(doc);
		for(int x = 0 ; x < orig.size() ;x++)
			System.out.println(orig.get(x));
			
		System.out.println("***************************************");
	
		Vector input = getCleanVector(doc);
		Vector output;
		for(int x = 0 ; x < input.size() ;x++)
			System.out.println(input.get(x));
	

			System.out.println(orig.size() + " and " + input.size());
		return input;
	}
	
	
}
