package unsw891.tester;

import java.io.*;

/*Usage:
 *java TestGenerator numChars
 *
 *where numChars is the number of characters you want generated. 2 points, the actual size of the file will be a lot bigger
 *than the number you specify because of various tags included, and the output is to standard out, so you'll have to
 *redirect to a file
 */

public class TestGenerator {

    private static char[] characters;

    public static void main(String[] args) {
	if (args.length > 0) {
	    int numChars = Integer.parseInt(args[0]);
	    characters = new char[numChars];
	    generateChars();
	    setProperties();
	} else {
	    System.out.println("Incorrect usage: Needs arguement for how many characters to generate");
	}
    }

    private static void generateChars() {
	for (int i = 0; i < characters.length; i++) {
	    char c = (char) (Math.random() * 0x7F);
	    //Checks they're valid characters, if not, generates a type of space. Includes testing for '>' and '<'
	    if (c < 0x21 || c > 0x7E || c == 0x3C || c == 0x3E) {
		int space = (int) (Math.random() * 4);
		switch (space) {
		case 0:
		    characters[i] = (char) 0x20;
		    break;
		case 1:
		    characters[i] = (char) 0x0D;
		    break;
		case 2:
		    characters[i] = (char) 0x0A;
		    break;
		case 3:
		    characters[i] = (char) 0x09;
		    break;
		}
	    } else {
		characters[i] = c;
	    }
	}
    }

    private static void setProperties() {
	for (int j = 0; j < characters.length; j++) {
	    byte rdm = (byte) (Math.random() * 2);
	    boolean b;
	    if (rdm == 1) {
		b = true;
	    } else {
		b = false;
	    }
	    rdm = (byte) (Math.random() * 2);
	    boolean em;
	    if (rdm == 1) {
		em = true;
	    } else {
		em = false;
	    }
	    rdm = (byte) (Math.random() * 2);
	    boolean i;
	    if (rdm == 1) {
		i = true;
	    } else {
		i = false;
	    }
	    rdm = (byte) (Math.random() * 2);
	    boolean s;
	    if (rdm == 1) {
		s = true;
	    } else {
		s = false;
	    }
	    rdm = (byte) (Math.random() * 2);
	    boolean tt;
	    if (rdm == 1) {
		tt = true;
	    } else {
		tt = false;
	    }
	    byte underline = (byte) (Math.random() * 4);
	    byte size = (byte) (Math.random() * 10);
	    byte col = (byte) (Math.random() * 8);
	    char colour;
	    switch (col) {
	    case 0:
		colour = 'r';
		break;
	    case 1:
		colour = 'g';
		break;
	    case 2:
		colour = 'b';
		break;
	    case 3:
		colour = 'c';
		break;
	    case 4:
		colour = 'm';
		break;
	    case 5:
		colour = 'y';
		break;
	    case 6:
		colour = 'k';
		break;
	    default:
		colour = 'w';
	    }
	    System.out.print(new Properties(characters[j], b, em, i, s, tt, underline, size, colour));
	}
    }
}
