package unsw891.util;

import unsw891.sml.*;
import java.util.Vector;

public class Converter {

	/**Return a vector containing PropertyRecord objects. Do not use
        this anymore -- Shard object will now be used in place of
        PropertyRecord. See getShardVector(Document doc).
       MODIFICATION
         1. lawry -- We will use Shard from now because it's easier for
                     the global optimiser
	 */
	public Vector Doc2PropertyRecordVector(Document doc) {
		System.err.println("unsw891.util.Converter.Doc2PropertyRecordVector()" +
            " - CALL getShardVector(Document), this method is NOT DONE!!");
		return new Vector();
	}
    
    
    /** Merges any amount of white spaces into just 1, even in between
        'words'. Example " ww  ds   dsf  fdfd dsdf" will become
        " ww ds dsf fdfd dsdf".
        [MODIFICATION]
        1.0 - lawry - since elim whitespace is easier done here while
                      converting, so even though I might be redundent
                      it might as well be so.
        */
    public static String fullTrim(String str) {
        // Define the 4 white space chars, may be I should use some
        // predefined from other classes, but I'll have to ask tomorrow.
        char ch_spc = '\040', ch_cr = '\015', ch_lf = '\012', ch_tab = '\011';


        boolean wspcfound = false; // set to true when 1 whitespc is discovered.
                                   // so we know to ignore the rest.
        int i, strlen = str.length();
        StringBuffer outs = new StringBuffer();
        
        for (i = 0; i < strlen; ++i) {
            char ch = str.charAt(i);

		if (ch == ch_spc || ch == ch_cr || ch == ch_lf || ch == ch_tab) {
      		    if (!wspcfound) {
                    wspcfound = true;
                    outs.append(ch);
                }
            } else {
                wspcfound = false;
                outs.append(ch);
            }
        }
        
        return outs.toString();
    }
    
    
    
    /** Return a vector containing unsw891.sml.Shard objects.
        MODIFICATION
        1. lawry  -- started to work on this in day 2.
        */
    public static Vector getShardVector(Document doc) {
        Debug.assert(doc.getType() == Document.TAG_ROOT,
            "Non-root document given to Converter!!!");
        
        // Create a default root-context stack, with 1 element on
        // that is the root context.
        ShardStack cstack = new ShardStack();
        cstack.push(Shard.getRootShard());
        
        // Okay, let the methods do the hard work.
        return rootPrint(doc.children, cstack);
    }
    
    
    /** This prints the vector from root context only. By print here
        where mean printing into vector of Shards.
        @return A vector of shards.
        */
    protected static Vector rootPrint(Vector vec, ShardStack stack) {
        // Define a vector which all method will add to. It is much
        // more efficient than merging vectors at the end of the day.
        Vector vshards = new Vector(100 /*random guess*/);
        
        int i, vsize = vec.size();
        for (i = 0; i < vsize; ++i)
            rprint((Document)vec.get(i), stack, vshards);
        return vshards;
    }
    
    
    
    /** Recursively print document from a node somewhere in the document
        tree.
        [MODIFICATION]
        1. simonb - neaten the size cases.
        2. lawry - fixed the bug in EM and S. see the cvs log.
        */
    protected static void rprint(Document doc, ShardStack stack, Vector vec) {
        Shard s;
        
        switch (doc.getType()) {

            case Document.TAG_0:
            case Document.TAG_1:
            case Document.TAG_2:
            case Document.TAG_3:
            case Document.TAG_4:
            case Document.TAG_5:
            case Document.TAG_6:
            case Document.TAG_7:
            case Document.TAG_8:
            case Document.TAG_9:
                s = new Shard(stack.peek());
                s.size = doc.getType()-Document.TAG_0;
            break;
            
            case Document.TAG_b:
                s = new Shard(stack.peek());
                s.colour = 'b';
            break;
            
            case Document.TAG_B:
                s = new Shard(stack.peek());
                s.setBold(true);
            break;
            
            case Document.TAG_c:
                s = new Shard(stack.peek());
                s.colour = 'c';
            break;
            
            case Document.TAG_EM:
                s = new Shard(stack.peek());
                if (! s.isStrong())
                    s.modify(Document.TAG_EM);
            break;
            
            case Document.TAG_g:
                s = new Shard(stack.peek());
                s.colour = 'g';
            break;
            
            case Document.TAG_I:
                s = new Shard(stack.peek());
                s.setItalic(true);
            break;
            
            case Document.TAG_INVALID:
                System.err.println("Converter: What?? Invalid Document, how can that...");
                s = Shard.getRootShard();
            break;
            
            case Document.TAG_k:
                s = new Shard(stack.peek());
                s.colour = 'k';
            break;
            
            case Document.TAG_m:
                s = new Shard(stack.peek());
                s.colour = 'm';
            break;
            
            case Document.TAG_PL:
                s = new Shard(stack.peek());
                s.setStrong(false);
                s.setEm(false);
                s.setItalic(false);
                s.setBold(false);
                s.setTT(false);
                s.setUnderline(0);
            break;
            
            case Document.TAG_r:
                s = new Shard(stack.peek());
                s.colour = 'r';
            break;
            
            case Document.TAG_ROOT:
                System.err.println("Converter: 2 root document????!!!");
                s = Shard.getRootShard();
            break;
            
            case Document.TAG_S:
                s = new Shard(stack.peek());
                s.setStrong(true);
                s.setEm(false);
            break;
            
            /**************************************
             *      WE HAVE HIT THE EXTERNODE     *
             **************************************/
             
            case Document.TAG_TEXT:
                // Add to vector.
                Shard sh = stack.peek();
                Debug.assert(sh != null, "At external node but stack empty" +
                    ". Using root shard and continuing.");
                if (sh == null)
                    s = Shard.getRootShard();
                else
                    s = new Shard(sh);
                
                // Check if it has <TT> set, if not we try to eliminate
                // white spaces.
                if (s.isTT())
                    s.text = doc.getText();
                else
                    s.text = fullTrim(doc.getText());

                vec.add(s);
            return; // exit
            
            case Document.TAG_TT:
                s = new Shard(stack.peek());
                s.setTT(true);
            break;
            
            case Document.TAG_U:
                s = new Shard(stack.peek());
                if (s.isUnderline() < 3)
                    s.setUnderline(1 + s.isUnderline());
            break;
            
            case Document.TAG_w:
                s = new Shard(stack.peek());
                s.colour = 'w';
            break;
            
            case Document.TAG_y:
                s = new Shard(stack.peek());
                s.colour = 'y';
            break;
            
            default:
                System.err.println("Converter: Unrecognised tag in " +
                    "document, using root shard.");
                s = Shard.getRootShard();
        }
        stack.push(s);
        
        // Recurse through all children from index 0 - max (left to right).
        Vector children = doc.children;
        int i, vsize = children.size();
        for (i = 0; i < vsize; ++i)
            rprint((Document)children.get(i), stack, vec);
        
        // Pop from stack.
        stack.pop();
    }
    
}
	
